#!/bin/bash

# Configure o diretorio temporario para armazenar os snapshots das VMs
XENBKPHOME=/backupXenServer; 

# Configure os UUIDs das VMs que farao o backup
VMS_UUID=""

############################################# Nao modificar ##########################################

start (){

	export XENBKPHOME;

	echo "Iniciando extrao das VM's. Este processo pode levar algumas horas!";

	mkdir -p $XENBKPHOME/SnapShotBkpMgrTmp > /dev/null 2>/dev/null;
	mkdir -p $XENBKPHOME/VMSBkpMgrTmp > /dev/null 2>/dev/null;

	for VM in $VMS_UUID; do

		LABEL=$(xe vm-list | grep -A1 $VM | grep label | awk '{print $4}')

		echo "Gerando snapshot da VM: $LABEL ($VM)..."

		if [ -z "$LABEL" ]; then
		    echo "VM nao identificada"
		    exit
		fi

		xe vm-snapshot uuid=$VM new-name-label="Recovery_BkpMgr_$LABEL" > $XENBKPHOME/SnapShotBkpMgrTmp/$VM.txt
		SS=$(cat $XENBKPHOME/SnapShotBkpMgrTmp/$VM.txt)
		xe template-param-set is-a-template=false uuid=$SS
		rm -f "$XENBKPHOME/VMSBkpMgrTmp/$LABEL.bkp"
		xe vm-export vm=$SS filename="$XENBKPHOME/VMSBkpMgrTmp/$LABEL.bkp"
		xe snapshot-uninstall force=true snapshot-uuid=$SS

		echo "OK"
	done

	rm -rf $XENBKPHOME/SnapShotBkpMgrTmp > /dev/null 2>/dev/null;

	echo "Extrao finalizada"
}

clean (){

	export XENBKPHOME;

	echo "Excluindo arquivos temporarios...";
	rm -rf $XENBKPHOME/SnapShotBkpMgrTmp > /dev/null 2>/dev/null;
	rm -rf $XENBKPHOME/VMSBkpMgrTmp > /dev/null 2>/dev/null;
	echo "OK";
}

# Executa o comando
$1
